/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : RNG1.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : RingBufferUInt8
**     Version     : Component 01.004, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2013-06-14, 20:55, # CodeGen: 5
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         Clear           - void RNG1_Clear(void);
**         Put             - byte RNG1_Put(byte elem);
**         Get             - byte RNG1_Get(byte *elemP);
**         NofElements     - byte RNG1_NofElements(void);
**         NofFreeElements - byte RNG1_NofFreeElements(void);
**         Init            - void RNG1_Init(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software of an embedded component for Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/
/*!
** @file RNG1.c
** @version 01.00
** @brief
**
*/         
/*!
**  @addtogroup RNG1_module RNG1 module documentation
**  @{
*/         

/* MODULE RNG1. */

#include "RNG1.h"

static uint8_t RNG1_buffer[RNG1_BUF_SIZE]; /* ring buffer */
static uint8_t RNG1_inIdx;  /* input index */
static uint8_t RNG1_outIdx; /* output index */
static uint8_t RNG1_inSize; /* size of input data */
/*
** ===================================================================
**     Method      :  RNG1_Put (component RingBufferUInt8)
**     Description :
**         Puts a new element into the buffer
**     Parameters  :
**         NAME            - DESCRIPTION
**         elem            - New element to be put into the buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RNG1_Put(byte elem)
{
  byte res = ERR_OK;

  EnterCritical();
  if (RNG1_inSize==RNG1_BUF_SIZE) {
    res = ERR_TXFULL;
  } else {
    RNG1_buffer[RNG1_inIdx] = elem;
    RNG1_inSize++;
    RNG1_inIdx++;
    if (RNG1_inIdx==RNG1_BUF_SIZE) {
      RNG1_inIdx = 0;
    }
  }
  ExitCritical();
  return res;
}

/*
** ===================================================================
**     Method      :  RNG1_Get (component RingBufferUInt8)
**     Description :
**         Removes an element from the buffer
**     Parameters  :
**         NAME            - DESCRIPTION
**       * elemP           - Pointer to where to store the received
**                           element
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RNG1_Get(byte *elemP)
{
  byte res = ERR_OK;

  EnterCritical();
  if (RNG1_inSize==0) {
    res = ERR_RXEMPTY;
  } else {
    *elemP = RNG1_buffer[RNG1_outIdx];
    RNG1_inSize--;
    RNG1_outIdx++;
    if (RNG1_outIdx==RNG1_BUF_SIZE) {
      RNG1_outIdx = 0;
    }
  }
  ExitCritical();
  return res;
}

/*
** ===================================================================
**     Method      :  RNG1_NofElements (component RingBufferUInt8)
**     Description :
**         Returns the actual number of elements in the buffer.
**     Parameters  : None
**     Returns     :
**         ---             - Number of elements in the buffer.
** ===================================================================
*/
byte RNG1_NofElements(void)
{
  return RNG1_inSize;
}

/*
** ===================================================================
**     Method      :  RNG1_NofFreeElements (component RingBufferUInt8)
**     Description :
**         Returns the actual number of free elements/space in the
**         buffer.
**     Parameters  : None
**     Returns     :
**         ---             - Number of elements in the buffer.
** ===================================================================
*/
byte RNG1_NofFreeElements(void)
{
  return (byte)(RNG1_BUF_SIZE-RNG1_inSize);
}

/*
** ===================================================================
**     Method      :  RNG1_Init (component RingBufferUInt8)
**     Description :
**         Initializes the data structure
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RNG1_Init(void)
{
  RNG1_inIdx = 0;
  RNG1_outIdx = 0;
  RNG1_inSize = 0;
}

/*
** ===================================================================
**     Method      :  RNG1_Clear (component RingBufferUInt8)
**     Description :
**         Clear (empty) the ring buffer.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RNG1_Clear(void)
{
  EnterCritical();
  RNG1_Init();
  ExitCritical();
}

/* END RNG1. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.2 [05.06]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
