/*
 * Program.c
 *
 *  Created on: Dec 14, 2012
 *      Author: SunRiver
 */


#include "BTM222.h"// nasz plik nagwkowy
#include "RNG1.h"	// biblioteka naszego bufora wygenerowana przez komponent RNG1
#include "AS1.h" 	// biblioteka Serial_LDD 

static UART_Desc deviceData;

static void SendChar(unsigned char ch, UART_Desc *desc) {
  desc->isSent = FALSE;  // uruchomi sie tylko raz podczas wysyania bloku
  while(AS1_SendBlock(desc->handle, (LDD_TData*)&ch, 1)!=ERR_OK) {} // Wysyanie znakw
  while(!desc->isSent) {} // oczekujemy na flage z przerwania TX
}
// ----------  Funkcja wysyania stringa ------------------------
static void SendString(const unsigned char *str,  UART_Desc *desc) {
  while(*str!='\0') {
    SendChar(*str++, desc);
  }
}

static void Init(void) {
  // -----------------  Inicjujemy struktur
  deviceData.handle = AS1_Init(&deviceData); 
  deviceData.isSent = FALSE;
  deviceData.rxChar = '\0';
  deviceData.rxPutFct = RNG1_Put;
  // ustawienie bufora odbiorczego  RX
  RNG1_Init(); // Inicjacja bufora 
  //ustawiamy ReceiveBlock() jako jedno bajtowy bufor i bdziemy go nazywa OnBlockReceived()
  while(AS1_ReceiveBlock(deviceData.handle, (LDD_TData *)&deviceData.rxChar, sizeof(deviceData.rxChar))!=ERR_OK) {} 
  // wykopujemy pocztkowe dane
}

// nasza funkcja startowa  -- Chyba nie musz tego tumaczu ?
void Prog_Start(void) {
  Init();
  SendString((unsigned char*)"FRDM wita bezprzewodowo. \r\n", &deviceData);
  for(;;) {
    if (RNG1_NofElements()!=0) {
      SendString((unsigned char*)"Napisz cos: ", &deviceData);
      while (RNG1_NofElements()!=0) {
        unsigned char ch;

        (void)RNG1_Get(&ch);
        SendChar(ch, &deviceData);
      }
      SendString((unsigned char*)"\r\n", &deviceData);
    }
  }
}
